/*
 * Copyright 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/* mview.h
 * -------
 *
 * $Revision: 1.16 $
 *
 */

/*
 * A sample is x,y fractional offsets from pixel center and a weight.
 */
typedef struct {
    float x, y, weight;
} SAMPLE;

/* 
 * A kernel is an array of samples 
 */
#define MAXSAMPLES  64
typedef struct {
    int numsamples;
    SAMPLE samples[MAXSAMPLES];
} KERNEL;

typedef struct model {
    char *name;
    char *bond, *atom;
} MODEL;

#define DATA_DIR "/usr/demos/data/atom/"

#define RE 1

extern char *ProgName;

extern int UsePrefposition;
extern int UsePrefsize;
extern int UsePanel;

extern int Debug;

extern unsigned int BackgroundColor;
extern char *BackgroundImageName;

extern int hwGfxType;
extern int hwAccbuf;
extern int hwMultisample;
extern int hwStereo;
extern int hwBitmapSpheres;

extern int SphereType;
extern int SphereDepth;
extern int SpherePrim;
extern int Hemi;
extern int Orient;
extern int Multisample;
extern int Stereo;
extern int Perspective;
extern int Depthcue;

extern int AtomAccBuf;
extern int BondAccBuf;
extern int InfoAccBuf;
extern int BondSmooth;
extern int BondEndCorrect;
extern int SpinMode;
extern int RollMode;
extern int BitmapSpheres;


extern int DispAtoms;
extern int DispBonds;
extern int DispInfo;

extern int FastDraw;

extern int ModelId;
extern MODEL *Models;
extern int NumModels;
extern char **ModelNames;

extern int KernelId;
extern char **Kernels;
extern int NumKernels;

extern char *KernelFile;

extern float ZoomFactor;
extern float RadScaleFactor;
extern float MaxRadScaleFactor;
extern float MinRadScaleFactor;

/****************************************************************************/

extern void DoHelp(long);
extern void DoExit(int);
extern char *get_basename(char *);
extern void InitKernels(void);
extern int HwAccBuf(void);
extern char *get_basename(char *);

