/*
 * Copyright 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
typedef struct attribs {
	int r, g, b;
	float nx, ny, nz;
} attribs;

typedef struct point {
	struct point 	*next;
	int 		type;
	attribs		*attr;
	float x, y, z;
} point;

typedef struct object {
   	struct object 	*next;
	int 		type;
	attribs		*attr;
	point 		*points;
} object;

#define FASTMAGIC	0x5423

typedef struct fastobj {
    int npoints;
    int colors;
    int type;
    int material;
    int display;
    int *data;
} fastobj;

fastobj *readfastobj();
fastobj *clonefastobj();

